]> arthur.barton.de Git - trigger-rcmd.git/blobdiff - scripts/trigger-rcmd
2017! :-)
[trigger-rcmd.git] / scripts / trigger-rcmd
index 90c19bdb18107d7c505cecff9502b97c91f402db..57408c40d870620e017edf4253605a39390b61b6 100755 (executable)
@@ -1,7 +1,7 @@
 #!/bin/sh
 #
 # trigger-rcmp: Trigger remote commands
-# Copyright (c)2014-2016 Alexander Barton (alex@barton.de)
+# Copyright (c)2014-2017 Alexander Barton (alex@barton.de)
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -10,7 +10,8 @@
 # Please read the file COPYING, README and AUTHORS for more information.
 #
 
-NAME=$(basename "$0")
+BASENAME=$(basename "$0")
+NAME="$BASENAME"
 RCMD_D="/usr/local/etc/rcmd.d"
 
 PATH="$PATH:/usr/local/sbin:/usr/sbin"
@@ -39,8 +40,6 @@ do_rcmd() {
                return 2
        fi
 
-       NAME="$NAME($1)"
-
        echo "$NAME: Checking system \"$SYSTEM\" ..."
        fping -c1 -q "$SYSTEM" 2>/dev/null
        if [ $? -ne 0 ]; then
@@ -124,7 +123,7 @@ do_rcmd() {
 NO_WAKE=
 
 # Check required tools
-for t in fping ssh etherwake; do
+for t in fping ssh etherwake lockfile-create; do
        if ! command -v "$t" >/dev/null 2>&1; then
                echo "$NAME: Required tool \"$t\" missing, aborting!"
                exit 3
@@ -153,8 +152,17 @@ while [ $# -gt 0 ]; do
                r=1
        else
                echo "$NAME: Working on \"$1\" - $(date "+%Y-%m-%d %H:%M:%S")"
-               do_rcmd "$1" ; r=$?
-               echo "$NAME: Done ($r) - $(date "+%Y-%m-%d %H:%M:%S")"
+               NAME="$BASENAME($1)"
+               lck="/run/lock/$NAME-$1.lock"
+               if lockfile-create --quiet --use-pid --retry 2 --lock-name "$lck"; then
+                       do_rcmd "$1" ; r=$?
+                       echo "$NAME: Done ($r) - $(date "+%Y-%m-%d %H:%M:%S")"
+                       rm -f "$lck"
+               else
+                       echo "$NAME: Failed to acquire lock file, skipping job! ($lck)"
+                       r=1
+               fi
+               NAME=$BASENAME
        fi
        [ $r -ne 0 ] && result=1
        shift